


pro cloud_boundary
cd, 'D:\playground\PollyXT-Arielle'
file='20190312_davos_pollyxt.nc'

height=get_nc_data(file,'height')
time=get_nc_data(file,'time')
beta=transpose(get_nc_data(file, 'att_beta_0532'))
ntime=n_elements(time)
nheight= n_elements(height)

;some init values, similar to Cloudnet
thres_beta=2e-5 ; as used in cloudnet
jump_gates=33 ; 250 m
min_jump=10 ; jump of beta within jump_gates above gate with thres_beta should be by a factor of min_jump

prev_time=0; init value fo variable
base_found=0;
file=file+'_liquid_cloud_bases.txt'
openw, lun, file, /GET_LUN

for i=0, ntime-1 do begin
    bin=0 ; init value of variable
    ;look for range gates where beta threshold is exceeded
    idx_thres=where(beta[i,*] ge thres_beta)
    ;if no idx_thres was found, continue to next i
    if idx_thres[0] eq -1 then continue

    ;loop over all idx_thres
    for j=0,n_elements(idx_thres)-1 do begin
        ;continue if the next range gate of beta>thres_beta appears directly after the previous one (as we only look for cloud bases)
        ;print, idx_thres[j], bin+jump_gates
        if idx_thres[j] lt bin+jump_gates then continue

       ;set the range bin to the j's available gate exceeding thres_beta
        bin=idx_thres[j]

        ;just check that bin+jump_gates does not exceed the max number of range gates
        if bin+jump_gates gt nheight-1 then continue

        ;calculate signal drop
        jump=beta[i,bin]/beta[i,bin+jump_gates]

       ;if jump exceeds a factor of min_jump then store the range gates as cloud base value
        if jump ge min_jump then begin
          base_found=1
          if time[i] eq prev_time then printf, lun, height[bin], Format='(F10.2, $)' else printf, lun, time[i], height[bin], format='(2F10.2, $)'
          prev_time=time[i]
        endif
    endfor
    if base_found eq 1 then printf, lun, ''
    base_found=0
endfor

Free_lun, lun

end